import QtQuick 2.12
import QtQuick.Window 2.12
import QtQuick.Controls 2.12

Dialog {
    x: 100
    y: 100
    width: 250
    height: 300
    modal: true
    focus: true
    closePolicy: Popup.CloseOnEscape | Popup.CloseOnPressOutsideParent
    standardButtons: Dialog.Ok

    Component.onCompleted: {
        standardButton(Dialog.Ok).text = qsTr("Ok")
    }

    contentItem: Pane {
        anchors.fill: parent
        anchors.margins: 0
        Text {
            id: aboutText
            height: 150
            text: qsTr("About Text")
            verticalAlignment: Text.AlignVCenter
            anchors.left: parent.left
            anchors.leftMargin: 10
            anchors.top: parent.top
            anchors.topMargin: 10
            anchors.right: parent.right
            anchors.rightMargin: 10
            font.pixelSize: 12
        }
        Grid {
            id: versionGrid
            columns: 2
            columnSpacing: 10

            anchors.top: aboutText.bottom
            anchors.topMargin: 10
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 10
            Label {
                id: versionLabel
                text: qsTr("Version")
                font.bold: true
            }
            Text {
                id: versionText
                text: controller.getVersion()
            }
            Label {
                id: commitLabel
                visible: commitText.text !== ""
                text: qsTr("Commit")
                font.bold: true
            }
            Text {
                id: commitText
                visible: commitText.text !== ""
                text: controller.getCommitHash()
            }
            Label {
                id: buildTimeLabel
                text: qsTr("Built at")
                font.bold: true
            }
            Text {
                id: buildTimeText
                text: controller.getBuildTime()
            }
        }
    }
}
