import QtQuick 2.12
import QtQuick.Controls.Material 2.12

Item {    
    function switchTheme(theme) {
        switch (theme) {
        case controller.CFG_VALUE_THEME_LIGHT:
            switchToLightTheme();
            break;
        case controller.CFG_VALUE_THEME_DARK:
            switchToDarkTheme();
            break;
        }
    }

    function toggleTheme() {
        if (mainWindow.Material.theme === mainWindow.Material.Light) {
            mainWindow.switchToDarkTheme();
        } else {
            mainWindow.switchToLightTheme();
        }
    }

    function switchToDarkTheme() {
        mainWindow.Material.theme = Material.Dark;
        mainWindow.Material.primary = "#222222"
    }

    function switchToLightTheme() {
        mainWindow.Material.theme = Material.Light;
    }

    function getAccentColor() {
        return mainWindow.Material.accent;
    }

    function getBackgroundColor() {
        return mainWindow.Material.background;
    }

    function getFontColor() {
        return mainWindow.Material.theme === mainWindow.Material.Light?
            "#000000"
            :"#FFFFFF";
    }

    function getMainWindowBackground() {
        return mainWindow.Material.theme === mainWindow.Material.Light?
            "#FFFFFF"
            :"#121212";
    }

    function getTableHeaderColor() {
        return mainWindow.Material.theme === mainWindow.Material.Light?
            "#CCCCCC"
            :"#121212";
    }

    function getTableSeparatorColor() {
        return mainWindow.Material.theme === mainWindow.Material.Light?
            "#000000"
            :"#A2A2A2";
    }
}
