#include "cupsutility.h"

#include <sstream>
#include <syscall.h>

#include <iostream>
CupsUtility::CupsUtility() {}

bool CupsUtility::addSmbPrinter(PrinterModel &printer) {
    return addSmbPrinter(printer, "");
}

bool CupsUtility::addSmbPrinter(PrinterModel &printer, std::string driver) {
    std::string cmdString = getCmd(printer, driver);
    std::cout << "Adding printer:" << std::endl;
    std::cout << cmdString << std::endl;
    int result = std::system(cmdString.c_str());
    if (result > 0) {
        return false;
    }
    return true;
}

std::string CupsUtility::getCmd(PrinterModel &printer) {
    return getCmd(printer, "");
}

std::string CupsUtility::getCmd(PrinterModel &printer, std::string driver) {
    std::stringstream printerUriStream;
    if (printer.getServer().find("smb://") != 0) {
        printerUriStream << "smb://";
    }
    printerUriStream << printer.getServer()
                     << "/" << printer.getName();


    std::stringstream cmdStream;
    cmdStream << CMD << " "
              << "-p '" << printer.getName() << "' "
              << "-E" << " "
              << "-m '" << printer.getDriver() << "' "
              << "-v '" << printerUriStream.str() << "' ";
    if (driver.length() > 0) {
        cmdStream << " -P '" << driver << "' ";
    }
    cmdStream << printer.getOpts();

    std::string cmdString = cmdStream.str();
    return cmdString;
}
