#ifndef PRINTERMODEL_H
#define PRINTERMODEL_H

#include <regex>
#include <string>

class PrinterModel {
public:
    PrinterModel(std::string name, std::string server, std::string location,
                 std::string driver, std::string format, std::string color,
                 std::string duplex, std::string staple, std::string punch,
                 std::string booklet, std::string scanner, std::string opts,
                 std::string comment);

    std::string getName();
    std::string getServer();
    std::string getLocation();
    std::string getDriver();
    std::string getFormat();
    bool getColor();
    bool getDuplex();
    bool getStaple();
    bool getPunch();
    bool getBooklet();
    std::string getScanner();
    std::string getOpts();
    std::string getComment();

    std::string getAtIndexAsStr(int index);

    /**
     * @brief Check if printer fields match the given regex
     * @param regex Regex to check for
     * @return True if printer matches
     */
    bool matches(const std::regex regex);

private:
    std::string name;
    std::string server;
    std::string location;
    std::string driver;
    std::string format;
    bool color;    
    bool duplex;
    bool staple;
    bool punch;
    bool booklet;
    std::string scanner;
    std::string opts;
    std::string comment;
};

#endif // PRINTERMODEL_H
