#include "stringutils.h"

#include <string>
#include <algorithm>

const std::string StringUtils::WHITESPACE = " \n\r\t\f\v";

std::string StringUtils::ltrim(const std::string& s) {
    size_t start = s.find_first_not_of(StringUtils::WHITESPACE);
    return (start == std::string::npos) ? "" : s.substr(start);
}

std::string StringUtils::rtrim(const std::string& s) {
    size_t end = s.find_last_not_of(StringUtils::WHITESPACE);
    return (end == std::string::npos) ? "" : s.substr(0, end + 1);
}

std::string StringUtils::trim(const std::string& s) {
    return rtrim(ltrim(s));
}
