#ifndef STRINGUTILS_H
#define STRINGUTILS_H

#include <string>

/**
 * @brief Class providing common string functions
 */
class StringUtils {
public:
    /**
     * @brief Trim leading whitespaces
     * @param s String to trim
     * @return Trimmed string
     */
    static std::string ltrim(const std::string& s);
    /**
     * @brief Trim trailing whitespaces
     * @param s String to trim
     * @return Trimmed string
     */
    static std::string rtrim(const std::string& s);
    /**
     * @brief Trim leading and trailing whitespaces
     * @param s String to trim
     * @return Trimmed string
     */
    static std::string trim(const std::string& s);
private:
    const static std::string WHITESPACE;
    StringUtils() {};
};

#endif // STRINGUTILS_H
