#ifndef TRANSLATOR_H
#define TRANSLATOR_H

#include <QObject>
#include <QQmlApplicationEngine>
#include <QTranslator>

class Translator : public QObject {
    Q_OBJECT
public:
    explicit Translator(QObject *parent = nullptr);

    void setEngine(QQmlApplicationEngine* engine);
    Q_INVOKABLE void switchLanguage(QString locale);
    void switchLanguage(std::string locale);

private:
    QTranslator *de_CH;
    QTranslator *en_US;
    QTranslator *autoLang;

    QQmlApplicationEngine *engine;

    std::map<std::string, QTranslator*> translators;
    QTranslator* current;

    void updateSystemLocale();

signals:

};

#endif // TRANSLATOR_H
